from Products.CMFCore.utils import getToolByName
from cStringIO import StringIO
from Products.MyMediaManager.General import TimeStamp
import zLOG, sys

def gotattr(obj, atttr):
    return hasattr(obj, attr)

def getDict(obj):
    return obj.__dict__

def getUserPass(user=None):
    if user is not None:
       password = user.getPassword()
    else:
       password = ''
    return password

def getTimeStamp(millis):
    return TimeStamp(millis)

def getUnrestrictedObject(self, path):
    try:        
        return self.unrestrictedTraverse(path)
    except:
        zLOG.LOG('Get unrestricted object', zLOG.ERROR, 'Failed getting object', error=sys.exc_info())

def writeLog(class_name, logtext):
    zLOG.LOG(class_name, zLOG.INFO, logtext)

def getTransitions(self):
    wf_tool = getToolByName(self, 'portal_workflow')
    transitionlist = []
    for id in wf_tool.getWorkflowIds():
        if id != 'collector_issue_workflow':
            wf = wf_tool.getWorkflowById(id)
            if hasattr(wf, 'transitions'):
                if hasattr(wf.transitions, '_mapping'):
                    for transition in wf.transitions._mapping.keys():
                        transition_dict = {}
                        tlist_def = wf.transitions._mapping[transition]
                        tranid = tlist_def.getId()
                        guard = tlist_def.getGuard()
                        a_tlist = {'id': tranid,}
                        name =  getattr(tlist_def, 'actbox_name', None)
                        if name: a_tlist['name'] = name
                        transition_dict['id'] = tranid
                        transition_dict['name'] = name
                        transition_dict['permission'] = guard.permissions
                        transition_dict['roles'] = guard.roles
                        transitionlist.append(transition_dict)

    actionlist = []
    for dict in transitionlist:
        add_new = 1
        for final_dict in actionlist:
            if final_dict['id'] == dict['id']:
                add_new = 0
        if add_new:
            new_dict = {}
            new_dict['id'] = dict['id']
            new_dict['name'] = dict['name']
            permlist = []
            for perm in dict['permission']:
                permlist.append(perm)
            new_dict['permission'] = permlist
            roleslist = []
            for role in dict['roles']:
                roleslist.append(role)
            new_dict['roles'] = roleslist
            actionlist.append(new_dict)

    if not actionlist:
        actionlist = [{'id': 'publish'
                     , 'name': 'Publish'
                     , 'permission': ['Review portal content']
                      }
                    , {'id': 'submit'
                     , 'name': 'Submit'
                     , 'permission': ['Request review']
                      }
                    , {'id': 'retract'
                     , 'name': 'Retract'
                     , 'permission': ['Request review']
                      }
                    , {'id': 'reject'
                     , 'name': 'Reject'
                     , 'permission': ['Review portal content']
                      }]

    return actionlist

def getDRMValues(self, REQUEST=None):
    """
    Bla bla
    """
    zLOG.LOG('get DRM Values', zLOG.INFO, 'Called drm get method')
    portal_object = getToolByName(self, 'portal_url').getPortalObject()
    member = getToolByName(self, 'portal_membership').getAuthenticatedMember()
    zLOG.LOG('get DRM Values', zLOG.INFO, 'Context url is %s' % self.absolute_url())

    if not REQUEST:
        request = self.REQUEST
    else:
        request = REQUEST            
    medianet = getToolByName(self, 'portal_medianet')
    utool = getToolByName(self, 'portal_url')

    zLOG.LOG('get DRM Values', zLOG.INFO, 'Before getting event')
    event = medianet.getEventFor(self)
    zLOG.LOG('get DRM Values', zLOG.INFO, 'Got event')

    servinfopath = request.get('servinfopath', None)
    zLOG.LOG('get DRM Values', zLOG.INFO, 'Servinfopath is %s' % servinfopath)
    if servinfopath:
        if servinfopath.find('/') != -1:
            pathlist = servinfopath.split('/')
            servinfoid = pathlist[-1]
            serverinfo = portal_object.getServerinfoHiddenObject(servinfopath)
        else:
            serverinfo = medianet.getServerinfoFor(event)
        request.set('serverid', serverinfo.getMediaServer().getId())

    src = medianet.getEditorUrlFor(event, request)
    zLOG.LOG('get DRM Values', zLOG.INFO, 'Src is %s' % src)
    metagen = medianet.getMetagenobjFor(event)

    if medianet.isLive(event):
        encprofile = serverinfo.getEncoderProfile()
        width = encprofile.getValue('width')
        height = encprofile.getValue('height')
    else:
        width = metagen and metagen.getRootXSize() or serverinfo.getValueFor('width')
        height = metagen and metagen.getRootYSize() or serverinfo.getValueFor('height')
    author = event.Creator()
    try:
        title = self.title_or_id()
    except:
        zLOG.LOG('get DRM Values', zLOG.ERROR, 'Failed getting title_or_id', error=sys.exc_info())
        try:
            title = self.Title()
        except:
            zLOG.LOG('get DRM Values', zLOG.ERROR, 'Failed getting Title', error=sys.exc_info())
            title = ''
    copyright = event.Rights()
    baseurl = self.restrictedTraverse(['',]).absolute_url()
    returndict = {'author': author
                , 'title': title
                , 'copyright': copyright
                , 'baseurl': baseurl
                , 'width': width
                , 'height': height
                , 'src': src
                }

    zLOG.LOG('get DRM Values', zLOG.INFO, 'Returndict is %s' % str(returndict))
    cliplist = []
    try:
        if self.meta_type == 'Media Manager Event':
            clips = self.listClips()
            if clips:
                for clip in clips:
                    cdict = {'begin': clip.getTcIn(), 'end': clip.getTcOut()}
                    cliplist.append(cdict)
            else:
                cliplist.append({})
        elif self.meta_type == 'Media Manager Media Clip':
            cliplist.append({'begin': self.getTcIn(), 'end': self.getTcOut()})
        else: #Don't know what we have then, but just play the file
            cliplist.append({})
    except:
        zLOG.LOG('get DRM Values', zLOG.ERROR, 'Failed getting clips', error=sys.exc_info())
    zLOG.LOG('get DRM Values', zLOG.INFO, 'Cliplist is %s' % str(cliplist))
    returndict['clips'] = cliplist
    return returndict
