##############################################################################
#    Copyright (C) 2003  MM Manager.org
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
##############################################################################


ADD_CONTENT_PERMISSION = 'Add portal content'

import Globals
from Globals import package_home
import zLOG
import os, cgi, sys, traceback, string
import PIL.Image
from cStringIO import StringIO
from OFS.Folder import Folder
from OFS.SimpleItem import SimpleItem
from Products.CMFCore import CMFCorePermissions
from Products.CMFCore.CMFCorePermissions import View
from Products.CMFCore.CMFCorePermissions import ManageProperties
from Products.CMFCore.CMFCatalogAware import CMFCatalogAware
from AccessControl import ClassSecurityInfo
from Acquisition import Implicit
from Products.CMFCore.PortalContent import PortalContent
#from Products.CMFCore.PortalFolder import PortalFolder
from Products.CMFCore.utils import getToolByName, expandpath
from Products.CMFCore.ActionInformation import ActionInformation
from Products.CMFCore.Expression import Expression
from Products.CMFDefault.DublinCore import DefaultDublinCoreImpl
from Products.PageTemplates.ZopePageTemplate import ZopePageTemplate

from Products.MyMediaManager.General import webcolors
from DateTime import DateTime
from Acquisition import aq_base, aq_parent, aq_inner
import Products.MyMediaManager.General
from Products.MyMediaManager.utils import ftp_upload
from Products.MyMediaManager.MediaSkinBase import MediaSkinBase

factory_type_information = ({
      'id': 'Media Cinema',
      'meta_type': 'Media Manager Media Cinema',
      'description': 'A Media Cinema is used to design syndicateable skins for media events',
      'product': 'MyMediaManager',
      'icon': 'mediacinema.gif',
      'factory': 'addMediaCinema',
      'filter_content_types': 0,
      'immediate_view': 'mediacinema_edit_form',
      'actions':
            (
                {'name': 'View'
               , 'id': 'view'
               , 'action': 'mediacinema_view'
               , 'permissions': (CMFCorePermissions.View,)
               , 'category': 'object'
               , 'visible': 1
                },
                #{'name': 'Preview'
               #, 'id': 'preview'
               #, 'action': 'mediacinema_preview'
               #, 'permissions': (CMFCorePermissions.ModifyPortalContent,)
               #, 'category': 'object'
               #, 'visible': 1
                #},
                {'name': 'Edit'
               , 'id': 'edit'
               , 'action': 'mediacinema_edit_form'
               , 'permissions': (CMFCorePermissions.ModifyPortalContent,)
               , 'category': 'object'
               , 'visible': 1
                },
                {'name': 'Metadata'
               , 'id': 'metadata'
               , 'action': 'metadata_edit_form'
               , 'permissions': (CMFCorePermissions.ModifyPortalContent,)
               , 'category': 'object'
               , 'visible': 1
                },
                {'name': 'Partnerskins'
               , 'id': 'partnerskins'
               , 'action': 'mediacinema_partner_form'
               , 'permissions': (CMFCorePermissions.ModifyPortalContent,)
               , 'category': 'object'
               , 'visible': 0
                }
            )
        },)

class MediaCinema( MediaSkinBase ):
    """
        A Media Cinema
    """

    __implements__ = ( PortalContent.__implements__
                     , DefaultDublinCoreImpl.__implements__
                     )

    meta_type='Media Manager Media Cinema'

    effective_date = expiration_date = None
    _isDiscussable = 0
    width = 0
    height = 0
    colors = webcolors
    partner_skins = {}
    playerpath = None
    playlistpath = None

    _default_content_fn = os.path.join(package_home(globals()),
                                       'www', 'mediacinema.html')

    security = ClassSecurityInfo()

    def __init__(self, id, title='', description=''):
        """
        constructor
        """
        MediaSkinBase.__init__(self, id, title=title, description=description)
        self.id=id
        self.title=title
        self.description=description
        self.width = 0
        self.height = 0
        self.partner_skins = {}
        self.playerpath = None
        self.playlistpath = None

    security.declareProtected(CMFCorePermissions.View, 'player_object')
    def player_object(self, REQUEST):
        """
        Returns HTML
        """
        if not REQUEST:
            REQUEST = self.REQUEST

        servinfopath = REQUEST.get('servinfopath', None)
        if servinfopath:
            portal = getToolByName(self, 'portal_url').getPortalObject()
            zLOG.LOG(self.meta_type, zLOG.INFO, 'Serverinfo path is %s' % servinfopath)
            serverinfo = portal.restrictedTraverse(servinfopath)
            skin = self.getPlayerSkin()
            event = serverinfo.aq_parent
            if skin:
                contentpath = REQUEST.get('contentpath')
                width = skin.player_width(REQUEST, skin.extra_width)
                height = skin.player_height(REQUEST, skin.extra_height)
                srcurl = "%s/mediaplayer_iframe_view?servinfopath=%s&contentpath=%s&cinemaskinpath=%s&referer_partner=%s" % \
                (skin.absolute_url()
               , servinfopath
               , contentpath
               , self.absolute_url(relative=1)
               , REQUEST.get('referer_partner', ''))
            else:
                mnet = getToolByName(self, 'portal_medianet')
                width = 0
                height = 0
                srcurl = "%s/cinema_player?servinfoid=%s&cinemaskinpath=%s" % (event.absolute_url(), serverinfo.getId(), self.absolute_url(relative=1))
                if mnet.isLive(event):
                    metagen = serverinfo.getValueFor('meta_generator', info_only=1)
                    genobj = None
                    if metagen:
                        try:
                            genobj = self.restrictedTraverse(metagen)
                        except:
                            pass
                    if genobj:
                        width = int(genobj.getRootXSize()) + 10
                        height = int(genobj.getRootYSize()) + 10
                    else:
                        encprofile = serverinfo.getEncoderProfile()
                        width = int(encprofile.getValue('width')) + 10
                        height = int(encprofile.getValue('height')) + 90
                else:
                    metagen = serverinfo.getValueFor('meta_generator', info_only=1)
                    genobj = None
                    if metagen:
                        try:
                            genobj = self.restrictedTraverse(metagen)
                        except:
                            zLOG.LOG(self.meta_type, zLOG.ERROR, 'Failed getting metagen obj', error=sys.exc_info())
                    if genobj:
                        width = int(genobj.getRootXSize()) + 10
                        height = int(genobj.getRootYSize()) + 90
                    else:
                        width = serverinfo.getValueFor('width')
                        zLOG.LOG(self.meta_type, zLOG.INFO, 'Width is %s' % width)
                        width = int(serverinfo.getValueFor('width')) + 10
                        height = int(serverinfo.getValueFor('height')) + 90
        else:
            width = 245
            height = 270
            srcurl = 'about:blank'

        html = """
        <iframe frameborder="0" marginheight="0" marginwidth="0" height="%d" width="%d"
         name="cinema_player" src="%s" scrolling="auto">
        </iframe>
        """
        return html % (height, width, srcurl)

    security.declareProtected(CMFCorePermissions.View, 'playlist_object')
    def playlist_object(self, REQUEST=None):
        """
        Returns HTML
        """
        if not REQUEST:
            REQUEST = self.REQUEST

        html = """
        <iframe src="%s" name="playlist" frameborder="0" marginheight="0" marginwidth="0"
         width="%s" height="%s" scrolling="auto">
        </iframe>
        """

        servinfopath = REQUEST.get('servinfopath', None)
        width = 200
        height = 200
        if servinfopath:
            portal = getToolByName(self, 'portal_url').getPortalObject()
            serverinfo = portal.restrictedTraverse(servinfopath)
            skin = self.getPlaylistSkin()
            event = serverinfo.aq_parent
            if skin:
                contentpath = REQUEST.get('contentpath')
                srcurl = "%s/mediaplaylist_iframe_view?servinfopath=%s&contentpath=%s&cinemaskinpath=%s&referer_partner=%s" % \
                (skin.absolute_url()
               , servinfopath
               , contentpath
               , self.absolute_url(relative=1)
               , REQUEST.get('referer_partner', ''))
                width = skin.width
                height = skin.height
            else:
                srcurl = "%s/event_playlist?servinfoid=%s&cinemaskinpath=%s" % (event.absolute_url(), serverinfo.getId(), self.absolute_url(relative=1))
            text = html % (srcurl, width, height)
        else:
            srcurl = ""
            text = html % ("about:blank", width, height)

        return text

    security.declareProtected(CMFCorePermissions.View, 'slide_object')
    def slide_object(self, REQUEST=None):
        """
        Returns HTML
        """
        html = """
        <iframe src="%s" name="picture" frameborder="0" marginheight="0" marginwidth="0"
         scrolling="no" width="%d" height="%d">
        </iframe>
        <iframe style="border: 0px;" frameborder="0" marginheight="0" marginwidth="0" height="0"
        width="0" name="buf_pic" src="about:blank"></iframe>
        """

        if not REQUEST:
            REQUEST = self.REQUEST

        servinfopath = REQUEST.get('servinfopath', None)
        width = 320
        height = 240
        if servinfopath:
            portal = getToolByName(self, 'portal_url').getPortalObject()
            serverinfo = portal.restrictedTraverse(servinfopath)
            event = serverinfo.aq_parent
            slideshows = event.objectValues('Media Manager Slide Show')
            if slideshows:
                slideshow = slideshows[0]
                width = slideshow.width
                height = slideshow.height
            srcurl = "%s/livepicture" % event.absolute_url()
            text = html % (srcurl, int(width), int(height))
        else:
            text = html % ("about:blank", width, height)

        return text

    security.declareProtected(CMFCorePermissions.View, 'illustration_object')
    def illustration_object(self, REQUEST=None, width=None, height=None):
        """
        Returns HTML
        """
        if not REQUEST:
            REQUEST = self.REQUEST

        html = """
        <iframe src="%s" name="illustration" frameborder="0"
         marginheight="0" marginwidth="0" scrolling="auto" width="%s"
         height="%s">
        </iframe>
        """

        servinfopath = REQUEST.get('servinfopath', None)
        if servinfopath:
            portal = getToolByName(self, 'portal_url').getPortalObject()
            serverinfo = portal.restrictedTraverse(servinfopath)
            event = serverinfo.aq_parent
            srcurl = "%s/event_illustration?cinemaskinpath=%s" % \
                (event.absolute_url(), self.absolute_url(relative=1))
        else:
            srcurl = "about:blank"
            
        if width is None:
            width = 100
        if height is None:
            height = 100

        text = html % (srcurl, width, height)
        return text

    security.declareProtected(CMFCorePermissions.ModifyPortalContent, 'setPlayerPath')
    def setPlayerPath(self, playerpath, REQUEST=None):
        """
        Set the path to the playerskin to use
        """
        self.playerpath = playerpath

        if REQUEST is not None:
            msg = 'Player path saved'
            req_url = REQUEST.get('HTTP_REFERER', None)
            if not req_url:
                req_url = "%s/mediacinema_edit_form" % self.absolute_url()
            has_q = req_url.find('?')
            if has_q != -1:
                req_url, trash = req_url.split('?')
            REQUEST.RESPONSE.redirect("%s?portal_status_message=%s" % (req_url, msg.replace(' ', '+')))

    security.declareProtected(CMFCorePermissions.View, 'getPlayerPath')
    def getPlayerPath(self):
        """
        Return the path to the playerskin to use
        """
        return getattr(self, 'playerpath', None)

    security.declareProtected(CMFCorePermissions.View, 'getPlayerSkin')
    def getPlayerSkin(self):
        """
        Return the playerskin to use
        """
        path = self.getPlayerPath()
        skin = None
        if path:
            portal = getToolByName(self, 'portal_url').getPortalObject()
            try:
                skin = portal.restrictedTraverse(path)
            except:
                pass
        return skin

    security.declareProtected(CMFCorePermissions.ModifyPortalContent, 'setPlaylistPath')
    def setPlaylistPath(self, playlistpath, REQUEST=None):
        """
        Set the path to the playlistskin to use
        """
        self.playlistpath = playlistpath

        if REQUEST is not None:
            msg = 'Playlist path saved'
            req_url = REQUEST.get('HTTP_REFERER', None)
            if not req_url:
                req_url = "%s/mediacinema_edit_form" % self.absolute_url()
            has_q = req_url.find('?')
            if has_q != -1:
                req_url, trash = req_url.split('?')
            REQUEST.RESPONSE.redirect("%s?portal_status_message=%s" % (req_url, msg.replace(' ', '+')))

    security.declareProtected(CMFCorePermissions.View, 'getPlaylistPath')
    def getPlaylistPath(self):
        """
        Return the path to the playlistskin to use
        """
        return getattr(self, 'playlistpath', None)

    security.declareProtected(CMFCorePermissions.View, 'getPlaylistSkin')
    def getPlaylistSkin(self):
        """
        Return the playlistskin to use
        """
        path = self.getPlaylistPath()
        skin = None
        if path:
            portal = getToolByName(self, 'portal_url').getPortalObject()
            try:
                skin = portal.restrictedTraverse(path)
            except:
                pass
        return skin

    security.declareProtected(CMFCorePermissions.ModifyPortalContent, 'setPartnerSkins')
    def setPartnerSkins(self, REQUEST=None, datadict=None):
        """
        Save the partner skins to be used for this cinema skin
        """
        if REQUEST is not None:
            req = REQUEST.form
            req_url = REQUEST.get('HTTP_REFERER', None)
            if not req_url:
                req_url = "%s/mediacinema_partner_form" % self.absolute_url()
            has_q = req_url.find('?')
            if has_q != -1:
                req_url, trash = req_url.split('?')
        else:
            req = datadict
            req_url = None

        skindict = {}
        partners = req.get('partnerids', [])
        for partnerid in partners:
            partnerskin = req.get('%s_skin' % partnerid, None)
            if partnerskin:
                skindict[partnerid] = partnerskin
        self.partner_skins = skindict
        self._p_changed = 1

        if req_url:
            msg = 'Partner skins saved'
            REQUEST.RESPONSE.redirect("%s?portal_status_message=%s" % (req_url, msg.replace(' ', '+')))

    security.declareProtected(CMFCorePermissions.View, 'getPartnerSkin')
    def getPartnerSkin(self, partnerid):
        """
        Return the partner skin object for the requested partner
        """
        skinpath = self.getPartnerSkinPath(partnerid)
        zLOG.LOG(self.meta_type, zLOG.INFO, 'Skin path for partner %s is %s' % (partnerid, skinpath))
        if skinpath:
            portal = getToolByName(self, 'portal_url').getPortalObject()
            try:
                skin = portal.restrictedTraverse(skinpath)
            except:
                skin = None
            return skin
        return None

    security.declareProtected(CMFCorePermissions.View, 'getPartnerSkinPath')
    def getPartnerSkinPath(self, partnerid):
        """
        Return the path to the partner skin for the requested partner
        """
        return self.partner_skins.get(partnerid, None)

def addMediaCinema(self, id, title='', REQUEST=None):
    """
    Add a media cinema
    """
    ob=MediaCinema(id,title)
    self._setObject(id, ob)

Globals.InitializeClass(MediaCinema)
