##############################################################################
#    Copyright (C) 2003  MM Manager.org
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
##############################################################################


ADD_CONTENT_PERMISSION = 'Add portal content'

import Globals
from Globals import DTMLFile, package_home, InitializeClass
import zLOG
import os, cgi, sys, traceback, string
import PIL.Image
from cStringIO import StringIO
from OFS.Folder import Folder
from OFS.SimpleItem import SimpleItem
from Products.CMFCore import CMFCorePermissions
from Products.CMFCore.CMFCorePermissions import View
from Products.CMFCore.CMFCorePermissions import ManageProperties
from Products.CMFCore.CMFCatalogAware import CMFCatalogAware
from Products.CMFCore.WorkflowCore import WorkflowAction
from AccessControl import ClassSecurityInfo, getSecurityManager
from Acquisition import Implicit
from TAL.TALDefs import TALESError
from Products.CMFCore.PortalContent import PortalContent
from Products.CMFCore.PortalFolder import PortalFolder
from Products.CMFCore.utils import getToolByName, expandpath
from Products.CMFCore.ActionInformation import ActionInformation
from Products.CMFCore.Expression import Expression
from Products.CMFDefault.DublinCore import DefaultDublinCoreImpl
from Products.PageTemplates import PageTemplate
from Products.PageTemplates.ZopePageTemplate import SecureModuleImporter
from Acquisition import Implicit, aq_parent, aq_inner
from Persistence import Persistent
from Products.CMFDefault.utils import *
from ExtensionClass import Base

from Products.MyMediaManager.General import webcolors
from DateTime import DateTime
from Acquisition import aq_base, aq_parent, aq_inner
import Products.MyMediaManager.General
from Products.MyMediaManager.utils import ftp_upload

_wwwdir = os.path.join(package_home(globals()), 'www')

class SkinPageTemplate(PageTemplate.PageTemplate, Implicit, Persistent):
    def pt_getContext(self):
        root = self.getPhysicalRoot()
        template = self #aq_parent(self)
        here = aq_parent(template)
        c = {'template': template,
             'options': {},
             'nothing': None,
             'request': None,
             'root': root,
             'request': getattr(root, 'REQUEST', None),
             'modules': SecureModuleImporter,
             'here': here,
             'container': aq_inner(here),
             }
        return c

    def __setstate__(self, state):
        SkinPageTemplate.inheritedAttribute('__setstate__')(self, state)
        self._cook()

class Macros(Base):
    """
    Evaluate to the macros collection of the contained page template.
    """
    def __of__( self, doc):
        return doc.get_pt().macros

class MediaSkinBase( DefaultDublinCoreImpl, PortalFolder, PortalContent):
    """
        A Media Skin
    """

    __implements__ = ( PortalContent.__implements__
                     , DefaultDublinCoreImpl.__implements__
                     )

    meta_type='Media Manager Media Skin Base'

    effective_date = expiration_date = None
    _isDiscussable = 0
    width = 400
    height = 300
    fgcolor = "black"
    bgcolor = "white"
    colors = webcolors

    manage_options = ( Folder.manage_options[:3] +
                       #ZopePageTemplate.manage_options[:3] +
                       ( { 'label'  : 'Edit',
                           'action' : 'manage_edit',
                           },
                          { 'label'  : 'Dublin Core',
                           'action' : 'manage_metadata',
                           }
                         ) +
                       CMFCatalogAware.manage_options +
                       SimpleItem.manage_options
                       )

    security = ClassSecurityInfo()

    security.declareProtected(CMFCorePermissions.View, 'macros')

    security.declareProtected(CMFCorePermissions.ModifyPortalContent,
                                  'manage_edit')

    manage_edit = DTMLFile('zmi_editDynamicDocument', _wwwdir)

    _default_content_fn = os.path.join(package_home(globals()),
                                       'www', 'mediacinema.html')

    def __init__( self
                , id
                , title=''
                , description=''
                , text=None
                ):
        """
        constructor
        """
        self._pt=SkinPageTemplate()
        DefaultDublinCoreImpl.__init__(self, title=title, description=description)
        zLOG.LOG('Media Skin Base init', zLOG.INFO, 'id: %s, title: %s' % (id, title))
        self.id=id
        self.title=title
        self.description=description
        if text is None:
            text = open(self._default_content_fn).read()
        self._pt.write(text)
        self.width = 0
        self.height = 0

    security.declareProtected(CMFCorePermissions.ModifyPortalContent, 'reset')
    def reset(self):
        """
        Reset the text to the default.
        """
        text = open(self._default_content_fn).read()
        self._pt.write(text)

    def get_pt(self):
        """
            return wrapped PageTemplate object.
        """
        return self._pt.__of__(self)

    def manage_editDocument(self, text, file='', REQUEST=None):
        """
          A ZMI (Zope Management Interface) level editing method.
        """
        self._edit(text, file)
        if REQUEST is not None:
            REQUEST['RESPONSE'].redirect(self.absolute_url()
                                         + '/manage_edit'
                                         + '?manage_tabs_message=Document+updated')

    def _edit(self, text):
        """
          Edit the document
        """
        pt = self.get_pt()
        pt.write(text)
        self.reindexObject()

    security.declareProtected(CMFCorePermissions.ModifyPortalContent, 'indexObject')
    def indexObject(self):
        """
        indexObject is overridden in PortalFolder so we
        re-override it here and call the method in PortalContent
        (which is actually defined in CMFCatalogAware)
        """
        PortalContent.indexObject(self)

    security.declareProtected(CMFCorePermissions.ModifyPortalContent, 'reindexObject')
    def reindexObject(self, idxs=[]):
        """
        re-override reindexObject
        """
        PortalContent.reindexObject(self, idxs)

    security.declareProtected(CMFCorePermissions.ModifyPortalContent, 'unindexObject')
    def unindexObject(self):
        """
        re-override unindexObject
        """
        PortalContent.unindexObject(self)

    #security.declarePrivate('_initSlideShow')
    def manage_afterAdd(self, item, container):
        # Recurse in the children (ObjectManager)
        PortalFolder.manage_afterAdd(self, item, container)
        # Add self to workflow and catalog
        PortalContent.manage_afterAdd(self, item, container)
        # XXX remember to move the initial sorting here

    security.declareProtected(ManageProperties, 'edit')
    def edit(self, title=None, text='', width=None, height=None, fgcolor=None, bgcolor=None):
        if title is not None:
           self.setTitle(title)

        if width is not None:
            self.width = width

        if height is not None:
            self.height = height

        if fgcolor is not None:
            self.fgcolor = fgcolor

        if bgcolor is not None:
            self.bgcolor = bgcolor

        text = bodyfinder(text)
        self._edit(text=text)


    def SearchableText(self):
        """
           Used by the catalog for basic full text indexing.
        """
        return "%s %s %s" % (self.Title(), self.Description(), self.get_pt().read())


    def CookedBody(self):
        """
           Return a rendering of the Dynamic Document.
        """
        security = getSecurityManager()
        security.addContext(self)
        try:
            try:
                result = self.get_pt().pt_render(
                    extra_context={'user': security.getUser()})
            except TALESError, err:
                if err.type == 'Unauthorized':
                    raise err.type, err.value, err.traceback
                raise
            return result
        finally:
            security.removeContext(self)

    def EditableBody(self):
        """
          The editable body of text.  This is the raw structured text
          or HTML.
        """
        return self.get_pt().read()

    def Format(self):
        """
            Returns a content-type style format of the underlying source
        """
        return self.get_pt().content_type

    def setFormat(self, value):
        """
           Ignore the value, as we only support text/html currently
        """
        self.get_pt().content_type = 'text/html'
    setFormat = WorkflowAction(setFormat)


class MediaSkinExtensionBase(DefaultDublinCoreImpl, PortalContent):
    """
        A Media Cinema Extension
    """

    __implements__ = ( PortalContent.__implements__
                     , DefaultDublinCoreImpl.__implements__
                     )

    meta_type='Media Manager Media Skin Extension Base'

    effective_date = expiration_date = None
    _isDiscussable = 0

    security = ClassSecurityInfo()

    security.declareProtected(CMFCorePermissions.View, 'macros')

    security.declareProtected(CMFCorePermissions.ModifyPortalContent,
                                  'manage_edit')

    manage_edit = DTMLFile('zmi_editDynamicDocument', _wwwdir)

    _default_content_fn = os.path.join(package_home(globals()),
                                       'www', 'mediaplayer.html')

    def __init__( self, id, title='', description='', text=None):
        """
        constructor
        """
        self._pt = SkinPageTemplate()
        DefaultDublinCoreImpl.__init__(self, title=title, description=description)
        zLOG.LOG('Media Skin Extension Base init', zLOG.INFO, 'id: %s, title: %s' % (id, title))
        self.id = id
        self.title = title
        self.description = description
        if text is None:
            text = open(self._default_content_fn).read()
        self._pt.write(text)

    security.declareProtected(CMFCorePermissions.ModifyPortalContent, 'reset')
    def reset(self):
        """
        Reset the text to the default.
        """
        text = open(self._default_content_fn).read()
        self._pt.write(text)

    def get_pt(self):
        """
            return wrapped PageTemplate object.
        """
        return self._pt.__of__(self)

    def manage_editDocument(self, text, file='', REQUEST=None):
        """
          A ZMI (Zope Management Interface) level editing method.
        """
        self._edit(text, file)
        if REQUEST is not None:
            REQUEST['RESPONSE'].redirect(self.absolute_url()
                                         + '/manage_edit'
                                         + '?manage_tabs_message=Document+updated')

    def _edit(self, text):
        """
          Edit the document
        """
        pt = self.get_pt()
        pt.write(text)
        self.reindexObject()

    security.declareProtected(ManageProperties, 'edit')
    def edit(self, title=None, text=''):
        if title is not None:
           self.setTitle(title)

        text = bodyfinder(text)
        self._edit(text=text)


    def SearchableText(self):
        """
           Used by the catalog for basic full text indexing.
        """
        return "%s %s %s" % (self.Title(), self.Description(), self.get_pt().read())


    def CookedBody(self):
        """
           Return a rendering of the Dynamic Document.
        """
        security = getSecurityManager()
        security.addContext(self)
        try:
            try:
                result = self.get_pt().pt_render(
                    extra_context={'user': security.getUser()})
            except TALESError, err:
                if err.type == 'Unauthorized':
                    raise err.type, err.value, err.traceback
                raise
            return result
        finally:
            security.removeContext(self)

    def EditableBody(self):
        """
          The editable body of text.  This is the raw structured text
          or HTML.
        """
        return self.get_pt().read()

    def Format(self):
        """
            Returns a content-type style format of the underlying source
        """
        return self.get_pt().content_type

    def setFormat(self, value):
        """
           Ignore the value, as we only support text/html currently
        """
        self.get_pt().content_type = 'text/html'
    setFormat = WorkflowAction(setFormat)
