##############################################################################
#    Copyright (C) 2001-2002  MMmanager.org
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
##############################################################################
"""
"""

ADD_FOLDERS_PERMISSION = 'Add portal folders'

#MMMCore
import zLOG
import Medianet
import MasterFile
import MediaEvent
import MediaClip
import MediaPermissions
import EncoderProfile
import MediaSubEvent
import MediaCinema
import MediaSkinExtensions
from Products.CMFCore.FSDTMLMethod import FSDTMLMethod

#CMF
from Products.CMFCore import utils
from Products.CMFCore.DirectoryView import registerFileExtension, registerDirectory

all_ftis = []
all_tools = []

contentClasses = (MasterFile.MasterFile
                    , MediaEvent.MediaEvent
                    , MediaClip.MediaClip
                    , EncoderProfile.EncoderProfile
                    , MediaSubEvent.SubEvent
                    , MediaCinema.MediaCinema
                    , MediaSkinExtensions.MediaPlayer
                    , MediaSkinExtensions.MediaPlaylist
                    )

contentConstructors = (MasterFile.addMasterFile
                        , MediaEvent.addMediaEvent
                        , MediaClip.addMediaClip
                        , EncoderProfile.addEncoderProfile
                        , MediaSubEvent.addSubEvent
                        , MediaCinema.addMediaCinema
                        , MediaSkinExtensions.addMediaPlayer
                        , MediaSkinExtensions.addMediaPlaylist
                        )

bases = contentClasses

tools = (Medianet.Medianet,)
import sys
this_module = sys.modules[ __name__ ]

z_bases = utils.initializeBasesPhase1( bases, this_module )
z_tool_bases = utils.initializeBasesPhase1( tools, this_module )

# This is used by a script (external method) that can be run
# to set up MMM in an existing CMF Site instance.
mmm_globals=globals()

#Make the skins availiable as DirectoryViews
registerDirectory('zpt_skins', globals())
registerDirectory('export_skins', globals())
registerDirectory('cps_skins', globals())
registerDirectory('plone_skins', globals())

# register javascript files as dtml methods
registerFileExtension('js', FSDTMLMethod)

def initialize( context ):
    import os

    #context.registerHelp(directory='help')
    #context.registerHelpTitle('Media Manager Help')

    utils.initializeBasesPhase2( z_bases, context )
    utils.initializeBasesPhase2( z_tool_bases, context )

    from Products.MyMediaManager import Plugins

    global all_ftis
    global all_tools

    all_tools.extend(tools)

    all_ftis.extend(MasterFile.factory_type_information)
    all_ftis.extend(MediaEvent.factory_type_information)
    all_ftis.extend(MediaClip.factory_type_information)
    all_ftis.extend(EncoderProfile.factory_type_information)
    all_ftis.extend(MediaSubEvent.factory_type_information)
    all_ftis.extend(MediaCinema.factory_type_information)
    all_ftis.extend(MediaSkinExtensions.factory_type_information)
    Plugins.initialize(context)

    utils.ToolInit( 'Media Manager Tools', tools = all_tools,
                     product_name = 'MyMediaManager', icon='tool.gif',
                    ).initialize( context )


    utils.ContentInit( 'Media Manager Content'
                     , content_types=contentClasses
                     , permission=ADD_FOLDERS_PERMISSION
                     , extra_constructors=contentConstructors
                     , fti = (all_ftis )
                     ).initialize( context )
